From 8d318d97cd0852c2d95c45250f85219ee3bdd6cd Mon Sep 17 00:00:00 2001
From: Sascha Wildner <saw@online.de>
Date: Sat, 15 Feb 2014 10:44:21 +0100
Subject: [PATCH 4/4] kernel: Sync ACPICA with Intel's version 20140214.

Module changes:

* Implemented a new mechanism to proactively prevent problems with
  ill-behaved reentrant control methods that create named ACPI objects.
  It should allow serialization of methods without leading to
  AE_ALREADY_EXISTS exceptions if the method was actually entered by
  more than one thread.

* Added the "Windows 2013" string to the _OSI support.

* Hardened/updated the _PRT return value auto-repair code.

* Added support to avoid the possibility of infinite loops when
  traversing object linked lists.

* Add #pragma pack({push,pop}) to ensure that ACPICA headers are
  independent of compiler settings or host headers.

Utilities changes:

* iasl(8): Fix a problem with support for the SPMI table. The first
    reserved field was incorrectly forced to have a value of zero
    instead of one.

* iasl(8): Removed the obsolete -g option.

* acpiexec(8): Added missing support for "Extra" and "Data" subobjects
    and for diplaying entire object linked lists.

For a more detailed list, see sys/contrib/dev/acpica/changes.txt.

As of this commit, the hw.acpi.serialize_methods tunable (0 by default)
is replaced with hw.acpi.auto_serialize_methods (1 by default). Users
with the former tunable set to 1 in their loader.conf should therefore
not experience any differences.
---
 share/man/man4/acpi.4                              |  14 +-
 sys/contrib/dev/acpica/changes.txt                 |  65 ++++
 .../dev/acpica/generate/unix/Makefile.config       |   5 +-
 sys/contrib/dev/acpica/source/common/adisasm.c     | 102 +-----
 sys/contrib/dev/acpica/source/common/dmextern.c    |  44 ++-
 sys/contrib/dev/acpica/source/common/dmtbinfo.c    |   2 +-
 .../dev/acpica/source/compiler/aslcompiler.h       |   8 +-
 sys/contrib/dev/acpica/source/compiler/aslerror.c  |  33 +-
 sys/contrib/dev/acpica/source/compiler/aslfileio.c | 113 ++++---
 sys/contrib/dev/acpica/source/compiler/aslglobal.h |   2 +-
 sys/contrib/dev/acpica/source/compiler/aslmain.c   |  11 -
 .../dev/acpica/source/compiler/aslmessages.h       |   2 +-
 .../dev/acpica/source/compiler/asloptions.c        |   8 +-
 sys/contrib/dev/acpica/source/compiler/aslpredef.c |  10 +-
 sys/contrib/dev/acpica/source/compiler/aslprepkg.c |  24 +-
 .../dev/acpica/source/compiler/aslstartup.c        |   4 +-
 .../dev/acpica/source/compiler/asltransform.c      |   9 -
 sys/contrib/dev/acpica/source/compiler/dtfield.c   |  34 +-
 .../dev/acpica/source/compiler/dttemplate.h        |   4 +-
 sys/contrib/dev/acpica/source/compiler/prmacros.c  |  13 +-
 .../acpica/source/components/debugger/dbdisply.c   |   4 +
 .../acpica/source/components/dispatcher/dsinit.c   |  61 +++-
 .../acpica/source/components/dispatcher/dsmethod.c | 139 ++++++++
 .../acpica/source/components/dispatcher/dswload.c  |  17 +
 .../dev/acpica/source/components/events/evregion.c |  12 +
 .../dev/acpica/source/components/executer/exdump.c | 222 +++++++++++--
 .../acpica/source/components/executer/exsystem.c   |  12 +-
 .../acpica/source/components/executer/exutils.c    |  90 +----
 .../acpica/source/components/namespace/nsinit.c    |   5 +-
 .../acpica/source/components/namespace/nsload.c    |   4 +-
 .../acpica/source/components/namespace/nsobject.c  |   9 +-
 .../acpica/source/components/namespace/nsprepkg.c  |  40 +--
 .../acpica/source/components/namespace/nsrepair.c  |  25 +-
 .../acpica/source/components/namespace/nsrepair2.c |  38 ++-
 .../dev/acpica/source/components/parser/psloop.c   |   5 +
 .../dev/acpica/source/components/parser/psobject.c |   7 +-
 .../acpica/source/components/resources/rscalc.c    |   2 +-
 .../acpica/source/components/resources/rscreate.c  |  10 +-
 .../acpica/source/components/resources/rsdump.c    |   2 +-
 .../source/components/resources/rsdumpinfo.c       |   2 +-
 .../acpica/source/components/resources/rsinfo.c    |   2 +-
 .../acpica/source/components/utilities/utdelete.c  |  16 +-
 .../acpica/source/components/utilities/utglobal.c  |  38 +--
 .../dev/acpica/source/components/utilities/utosi.c |  29 ++
 sys/contrib/dev/acpica/source/include/acapps.h     |  10 +-
 sys/contrib/dev/acpica/source/include/acbuffer.h   |   5 +
 sys/contrib/dev/acpica/source/include/acconfig.h   |   4 +
 sys/contrib/dev/acpica/source/include/acdebug.h    |   4 +
 sys/contrib/dev/acpica/source/include/acdisasm.h   |   4 +
 sys/contrib/dev/acpica/source/include/acdispat.h   |  18 +-
 sys/contrib/dev/acpica/source/include/acevents.h   |   4 +
 sys/contrib/dev/acpica/source/include/acexcep.h    |   4 +
 sys/contrib/dev/acpica/source/include/acglobal.h   | 364 ++++++++++-----------
 sys/contrib/dev/acpica/source/include/achware.h    |   4 +
 sys/contrib/dev/acpica/source/include/acinterp.h   |  16 +-
 sys/contrib/dev/acpica/source/include/aclocal.h    |   4 +
 sys/contrib/dev/acpica/source/include/acmacros.h   |   4 +
 sys/contrib/dev/acpica/source/include/acnamesp.h   |   4 +
 sys/contrib/dev/acpica/source/include/acobject.h   |   4 +-
 sys/contrib/dev/acpica/source/include/acoutput.h   |   4 +
 sys/contrib/dev/acpica/source/include/acparser.h   |   4 +
 sys/contrib/dev/acpica/source/include/acpiosxf.h   |   4 +
 sys/contrib/dev/acpica/source/include/acpixf.h     |   8 +-
 sys/contrib/dev/acpica/source/include/acpredef.h   |  18 +-
 sys/contrib/dev/acpica/source/include/acresrc.h    |   4 +
 sys/contrib/dev/acpica/source/include/acrestyp.h   |   4 +
 sys/contrib/dev/acpica/source/include/acstruct.h   |   8 +
 sys/contrib/dev/acpica/source/include/actables.h   |   4 +
 sys/contrib/dev/acpica/source/include/actbl.h      |   4 +
 sys/contrib/dev/acpica/source/include/actbl1.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actbl2.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actbl3.h     |   6 +-
 sys/contrib/dev/acpica/source/include/actypes.h    |   4 +
 sys/contrib/dev/acpica/source/include/acutils.h    |   5 +
 sys/contrib/dev/acpica/source/include/amlcode.h    |   5 +
 sys/contrib/dev/acpica/source/include/amlresrc.h   |   5 +
 .../source/os_specific/service_layers/oswindir.c   |   1 +
 .../source/os_specific/service_layers/oswinxf.c    |  27 --
 .../dev/acpica/source/tools/acpiexec/aecommon.h    |   5 +
 .../dev/acpica/source/tools/acpiexec/aeexec.c      |   2 +-
 .../dev/acpica/source/tools/acpiexec/aehandlers.c  |   2 +-
 .../dev/acpica/source/tools/acpiexec/aemain.c      |  13 +-
 sys/dev/acpica/acpi.c                              |  14 +-
 83 files changed, 1229 insertions(+), 685 deletions(-)

diff --git a/sys/contrib/dev/acpica/source/common/adisasm.c b/sys/contrib/dev/acpica/source/common/adisasm.c
index 538efe4..2a8fac3 100644
--- a/sys/contrib/dev/acpica/source/common/adisasm.c
+++ b/sys/contrib/dev/acpica/source/common/adisasm.c
@@ -250,7 +250,6 @@ AdInitialize (
  *              OutToFile           - TRUE if output should go to a file
  *              Prefix              - Path prefix for output
  *              OutFilename         - where the filename is returned
- *              GetAllTables        - TRUE if all tables are desired
  *
  * RETURN:      Status
  *
@@ -263,8 +262,7 @@ AdAmlDisassemble (
     BOOLEAN                 OutToFile,
     char                    *Filename,
     char                    *Prefix,
-    char                    **OutFilename,
-    BOOLEAN                 GetAllTables)
+    char                    **OutFilename)
 {
     ACPI_STATUS             Status;
     char                    *DisasmFilename = NULL;
@@ -348,7 +346,7 @@ AdAmlDisassemble (
     }
     else
     {
-        Status = AdGetLocalTables (Filename, GetAllTables);
+        Status = AdGetLocalTables ();
         if (ACPI_FAILURE (Status))
         {
             AcpiOsPrintf ("Could not get ACPI tables, %s\n",
@@ -746,8 +744,7 @@ AdDisplayTables (
  *
  * FUNCTION:    AdGetLocalTables
  *
- * PARAMETERS:  Filename            - Not used
- *              GetAllTables        - TRUE if all tables are desired
+ * PARAMETERS:  None
  *
  * RETURN:      Status
  *
@@ -757,105 +754,36 @@ AdDisplayTables (
 
 ACPI_STATUS
 AdGetLocalTables (
-    char                    *Filename,
-    BOOLEAN                 GetAllTables)
+    void)
 {
     ACPI_STATUS             Status;
     ACPI_TABLE_HEADER       TableHeader;
     ACPI_TABLE_HEADER       *NewTable;
-    UINT32                  NumTables;
-    UINT32                  PointerSize;
     UINT32                  TableIndex;
 
 
-    if (GetAllTables)
-    {
-        ACPI_MOVE_32_TO_32 (TableHeader.Signature, ACPI_SIG_RSDT);
-        AcpiOsTableOverride (&TableHeader, &NewTable);
-        if (!NewTable)
-        {
-            fprintf (stderr, "Could not obtain RSDT\n");
-            return (AE_NO_ACPI_TABLES);
-        }
-        else
-        {
-            AdWriteTable (NewTable, NewTable->Length,
-                ACPI_SIG_RSDT, NewTable->OemTableId);
-        }
-
-        if (ACPI_COMPARE_NAME (NewTable->Signature, ACPI_SIG_RSDT))
-        {
-            PointerSize = sizeof (UINT32);
-        }
-        else
-        {
-            PointerSize = sizeof (UINT64);
-        }
-
-        /*
-         * Determine the number of tables pointed to by the RSDT/XSDT.
-         * This is defined by the ACPI Specification to be the number of
-         * pointers contained within the RSDT/XSDT. The size of the pointers
-         * is architecture-dependent.
-         */
-        NumTables = (NewTable->Length - sizeof (ACPI_TABLE_HEADER)) / PointerSize;
-        AcpiOsPrintf ("There are %u tables defined in the %4.4s\n\n",
-            NumTables, NewTable->Signature);
-
-        /* Get the FADT */
-
-        ACPI_MOVE_32_TO_32 (TableHeader.Signature, ACPI_SIG_FADT);
-        AcpiOsTableOverride (&TableHeader, &NewTable);
-        if (NewTable)
-        {
-            AdWriteTable (NewTable, NewTable->Length,
-                ACPI_SIG_FADT, NewTable->OemTableId);
-        }
-        AcpiOsPrintf ("\n");
-
-        /* Don't bother with FACS, it is usually all zeros */
-    }
-
-    /* Always get the DSDT */
+    /* Get the DSDT via table override */
 
     ACPI_MOVE_32_TO_32 (TableHeader.Signature, ACPI_SIG_DSDT);
     AcpiOsTableOverride (&TableHeader, &NewTable);
-    if (NewTable)
-    {
-        AdWriteTable (NewTable, NewTable->Length,
-            ACPI_SIG_DSDT, NewTable->OemTableId);
-
-        /* Store DSDT in the Table Manager */
-
-        Status = AcpiTbStoreTable (0, NewTable, NewTable->Length,
-                    0, &TableIndex);
-        if (ACPI_FAILURE (Status))
-        {
-            fprintf (stderr, "Could not store DSDT\n");
-            return (AE_NO_ACPI_TABLES);
-        }
-    }
-    else
+    if (!NewTable)
     {
         fprintf (stderr, "Could not obtain DSDT\n");
         return (AE_NO_ACPI_TABLES);
     }
 
-#if 0
-    /* TBD: Future implementation */
+    AdWriteTable (NewTable, NewTable->Length,
+        ACPI_SIG_DSDT, NewTable->OemTableId);
 
-    AcpiOsPrintf ("\n");
+    /* Store DSDT in the Table Manager */
 
-    /* Get all SSDTs */
-
-    ACPI_MOVE_32_TO_32 (TableHeader.Signature, ACPI_SIG_SSDT);
-    do
+    Status = AcpiTbStoreTable (0, NewTable, NewTable->Length,
+                0, &TableIndex);
+    if (ACPI_FAILURE (Status))
     {
-        NewTable = NULL;
-        Status = AcpiOsTableOverride (&TableHeader, &NewTable);
-
-    } while (NewTable);
-#endif
+        fprintf (stderr, "Could not store DSDT\n");
+        return (AE_NO_ACPI_TABLES);
+    }
 
     return (AE_OK);
 }
diff --git a/sys/contrib/dev/acpica/source/common/dmextern.c b/sys/contrib/dev/acpica/source/common/dmextern.c
index 82b24d1..ba0041c 100644
--- a/sys/contrib/dev/acpica/source/common/dmextern.c
+++ b/sys/contrib/dev/acpica/source/common/dmextern.c
@@ -1265,10 +1265,16 @@ AcpiDmUnresolvedWarning (
                 "     * were not specified. This resulting disassembler output file may not\n"
                 "     * compile because the disassembler did not know how many arguments\n"
                 "     * to assign to these methods. To specify the tables needed to resolve\n"
-                "     * external control method references, use the one of the following\n"
-                "     * example iASL invocations:\n"
-                "     *     iasl -e <ssdt1.aml,ssdt2.aml...> -d <dsdt.aml>\n"
-                "     *     iasl -e <dsdt.aml,ssdt2.aml...> -d <ssdt1.aml>\n"
+                "     * external control method references, the -e option can be used to\n"
+                "     * specify the filenames. Example iASL invocations:\n"
+                "     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml\n"
+                "     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml\n"
+                "     *     iasl -e ssdt*.aml -d dsdt.aml\n"
+                "     *\n"
+                "     * In addition, the -fe option can be used to specify a file containing\n"
+                "     * control method external declarations with the associated method\n"
+                "     * argument counts. Each line of the file must be of the form:\n"
+                "     *     External (<method pathname>, MethodObj, <argument count>)\n"
                 "     */\n",
                 AcpiGbl_NumExternalMethods);
         }
@@ -1279,10 +1285,15 @@ AcpiDmUnresolvedWarning (
             AcpiOsPrintf ("    /*\n"
                 "     * iASL Warning: There were %u external control methods found during\n"
                 "     * disassembly, but only %u %s resolved (%u unresolved). Additional\n"
-                "     * ACPI tables are required to properly disassemble the code. This\n"
+                "     * ACPI tables may be required to properly disassemble the code. This\n"
                 "     * resulting disassembler output file may not compile because the\n"
                 "     * disassembler did not know how many arguments to assign to the\n"
                 "     * unresolved methods.\n"
+                "     *\n"
+                "     * If necessary, the -fe option can be used to specify a file containing\n"
+                "     * control method external declarations with the associated method\n"
+                "     * argument counts. Each line of the file must be of the form:\n"
+                "     *     External (<method pathname>, MethodObj, <argument count>)\n"
                 "     */\n",
                 AcpiGbl_NumExternalMethods, AcpiGbl_ResolvedExternalMethods,
                 (AcpiGbl_ResolvedExternalMethods > 1 ? "were" : "was"),
@@ -1301,10 +1312,16 @@ AcpiDmUnresolvedWarning (
                 "were not specified. The resulting disassembler output file may not\n"
                 "compile because the disassembler did not know how many arguments\n"
                 "to assign to these methods. To specify the tables needed to resolve\n"
-                "external control method references, use the one of the following\n"
-                "example iASL invocations:\n"
-                "    iasl -e <ssdt1.aml,ssdt2.aml...> -d <dsdt.aml>\n"
-                "    iasl -e <dsdt.aml,ssdt2.aml...> -d <ssdt1.aml>\n",
+                "external control method references, the -e option can be used to\n"
+                "specify the filenames. Example iASL invocations:\n"
+                "    iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml\n"
+                "    iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml\n"
+                "    iasl -e ssdt*.aml -d dsdt.aml\n"
+                "\n"
+                "In addition, the -fe option can be used to specify a file containing\n"
+                "control method external declarations with the associated method\n"
+                "argument counts. Each line of the file must be of the form:\n"
+                "    External (<method pathname>, MethodObj, <argument count>)\n",
                 AcpiGbl_NumExternalMethods);
         }
         else if (AcpiGbl_NumExternalMethods != AcpiGbl_ResolvedExternalMethods)
@@ -1314,10 +1331,15 @@ AcpiDmUnresolvedWarning (
             fprintf (stderr, "\n"
                 "iASL Warning: There were %u external control methods found during\n"
                 "disassembly, but only %u %s resolved (%u unresolved). Additional\n"
-                "ACPI tables are required to properly disassemble the code. The\n"
+                "ACPI tables may be required to properly disassemble the code. The\n"
                 "resulting disassembler output file may not compile because the\n"
                 "disassembler did not know how many arguments to assign to the\n"
-                "unresolved methods.\n",
+                "unresolved methods.\n"
+                "\n"
+                "If necessary, the -fe option can be used to specify a file containing\n"
+                "control method external declarations with the associated method\n"
+                "argument counts. Each line of the file must be of the form:\n"
+                "    External (<method pathname>, MethodObj, <argument count>)\n",
                 AcpiGbl_NumExternalMethods, AcpiGbl_ResolvedExternalMethods,
                 (AcpiGbl_ResolvedExternalMethods > 1 ? "were" : "was"),
                 (AcpiGbl_NumExternalMethods - AcpiGbl_ResolvedExternalMethods));
diff --git a/sys/contrib/dev/acpica/source/common/dmtbinfo.c b/sys/contrib/dev/acpica/source/common/dmtbinfo.c
index b719c97..13c9a59 100644
--- a/sys/contrib/dev/acpica/source/common/dmtbinfo.c
+++ b/sys/contrib/dev/acpica/source/common/dmtbinfo.c
@@ -1940,7 +1940,7 @@ ACPI_DMTABLE_INFO           AcpiDmTableInfoSpcr[] =
 ACPI_DMTABLE_INFO           AcpiDmTableInfoSpmi[] =
 {
     {ACPI_DMT_UINT8,    ACPI_SPMI_OFFSET (InterfaceType),           "Interface Type", 0},
-    {ACPI_DMT_UINT8,    ACPI_SPMI_OFFSET (Reserved),                "Reserved", 0},
+    {ACPI_DMT_UINT8,    ACPI_SPMI_OFFSET (Reserved),                "Reserved", DT_NON_ZERO}, /* Value must be 1 */
     {ACPI_DMT_UINT16,   ACPI_SPMI_OFFSET (SpecRevision),            "IPMI Spec Version", 0},
     {ACPI_DMT_UINT8,    ACPI_SPMI_OFFSET (InterruptType),           "Interrupt Type", 0},
     {ACPI_DMT_UINT8,    ACPI_SPMI_OFFSET (GpeNumber),               "GPE Number", 0},
diff --git a/sys/contrib/dev/acpica/source/compiler/aslerror.c b/sys/contrib/dev/acpica/source/compiler/aslerror.c
index 77b167b..a60f608 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslerror.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslerror.c
@@ -56,6 +56,36 @@ AeAddToErrorLog (
 
 /*******************************************************************************
  *
+ * FUNCTION:    AslAbort
+ *
+ * PARAMETERS:  None
+ *
+ * RETURN:      None
+ *
+ * DESCRIPTION: Dump the error log and abort the compiler. Used for serious
+ *              I/O errors.
+ *
+ ******************************************************************************/
+
+void
+AslAbort (
+    void)
+{
+
+    AePrintErrorLog (ASL_FILE_STDERR);
+    if (Gbl_DebugFlag)
+    {
+        /* Print error summary to stdout also */
+
+        AePrintErrorLog (ASL_FILE_STDOUT);
+    }
+
+    exit (1);
+}
+
+
+/*******************************************************************************
+ *
  * FUNCTION:    AeClearErrorLog
  *
  * PARAMETERS:  None
@@ -817,7 +847,8 @@ AslError (
 
     /* Check if user wants to ignore this exception */
 
-    if (AslIsExceptionDisabled (Level, MessageId))
+    if (Gbl_AllExceptionsDisabled ||
+        AslIsExceptionDisabled (Level, MessageId))
     {
         return;
     }
diff --git a/sys/contrib/dev/acpica/source/compiler/aslfileio.c b/sys/contrib/dev/acpica/source/compiler/aslfileio.c
index 2485ec3..90072f1 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslfileio.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslfileio.c
@@ -46,35 +46,9 @@
 #define _COMPONENT          ACPI_COMPILER
         ACPI_MODULE_NAME    ("aslfileio")
 
-
-/*******************************************************************************
- *
- * FUNCTION:    AslAbort
- *
- * PARAMETERS:  None
- *
- * RETURN:      None
- *
- * DESCRIPTION: Dump the error log and abort the compiler. Used for serious
- *              I/O errors.
- *
- ******************************************************************************/
-
-void
-AslAbort (
-    void)
-{
-
-    AePrintErrorLog (ASL_FILE_STDERR);
-    if (Gbl_DebugFlag)
-    {
-        /* Print error summary to stdout also */
-
-        AePrintErrorLog (ASL_FILE_STDOUT);
-    }
-
-    exit (1);
-}
+long
+UtGetFileSize (
+    FILE                    *fp);
 
 
 /*******************************************************************************
@@ -141,13 +115,73 @@ FlOpenFile (
 
 /*******************************************************************************
  *
+ * FUNCTION:    UtGetFileSize
+ *
+ * PARAMETERS:  fp              - Open file handle
+ *
+ * RETURN:      File Size. -1 on error.
+ *
+ * DESCRIPTION: Get current file size. Uses seek-to-EOF. File must be open.
+ *              TBD: This function should be used to replace other similar
+ *              functions in ACPICA.
+ *
+ ******************************************************************************/
+
+long
+UtGetFileSize (
+    FILE                    *fp)
+{
+    long                    FileSize;
+    long                    CurrentOffset;
+
+
+    CurrentOffset = ftell (fp);
+    if (CurrentOffset < 0)
+    {
+        goto OffsetError;
+    }
+
+    if (fseek (fp, 0, SEEK_END))
+    {
+        goto SeekError;
+    }
+
+    FileSize = ftell (fp);
+    if (FileSize < 0)
+    {
+        goto OffsetError;
+    }
+
+    /* Restore file pointer */
+
+    if (fseek (fp, CurrentOffset, SEEK_SET))
+    {
+        goto SeekError;
+    }
+
+    return (FileSize);
+
+
+OffsetError:
+    perror ("Could not get file offset");
+    return (-1);
+
+SeekError:
+    perror ("Could not seek file");
+    return (-1);
+}
+
+
+/*******************************************************************************
+ *
  * FUNCTION:    FlGetFileSize
  *
  * PARAMETERS:  FileId              - Index into file info array
  *
  * RETURN:      File Size
  *
- * DESCRIPTION: Get current file size. Uses seek-to-EOF. File must be open.
+ * DESCRIPTION: Get current file size. Uses common seek-to-EOF function.
+ *              File must be open. Aborts compiler on error.
  *
  ******************************************************************************/
 
@@ -155,21 +189,16 @@ UINT32
 FlGetFileSize (
     UINT32                  FileId)
 {
-    FILE                    *fp;
-    UINT32                  FileSize;
-    long                    Offset;
-
+    long                    FileSize;
 
-    fp = Gbl_Files[FileId].Handle;
-    Offset = ftell (fp);
 
-    fseek (fp, 0, SEEK_END);
-    FileSize = (UINT32) ftell (fp);
-
-    /* Restore file pointer */
+    FileSize = UtGetFileSize (Gbl_Files[FileId].Handle);
+    if (FileSize == -1)
+    {
+        AslAbort();
+    }
 
-    fseek (fp, Offset, SEEK_SET);
-    return (FileSize);
+    return ((UINT32) FileSize);
 }
 
 
diff --git a/sys/contrib/dev/acpica/source/compiler/aslglobal.h b/sys/contrib/dev/acpica/source/compiler/aslglobal.h
index 2024854..2707f4d 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslglobal.h
+++ b/sys/contrib/dev/acpica/source/compiler/aslglobal.h
@@ -159,7 +159,6 @@ ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_NoErrors, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_WarningsAsErrors, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_NoResourceChecking, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_DisasmFlag, FALSE);
-ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_GetAllTables, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_IntegerOptimizationFlag, TRUE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_ReferenceOptimizationFlag, TRUE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_DisplayRemarks, TRUE);
@@ -170,6 +169,7 @@ ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_UseOriginalCompilerId,
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_VerboseTemplates, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_DoTemplates, FALSE);
 ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_CompileGeneric, FALSE);
+ASL_EXTERN BOOLEAN                  ASL_INIT_GLOBAL (Gbl_AllExceptionsDisabled, FALSE);
 
 
 #define HEX_OUTPUT_NONE             0
diff --git a/sys/contrib/dev/acpica/source/compiler/aslmain.c b/sys/contrib/dev/acpica/source/compiler/aslmain.c
index 20468e5..6f81d21 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslmain.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslmain.c
@@ -158,7 +158,6 @@ Usage (
     ACPI_OPTION ("",                "  (Obtain DSDT from current system if no input file)");
     ACPI_OPTION ("-e  <f1 f2 ...>", "Include ACPI table(s) for external symbol resolution");
     ACPI_OPTION ("-fe <file>",      "Specify external symbol declaration file");
-    ACPI_OPTION ("-g",              "Get ACPI tables and write to files (*.dat)");
     ACPI_OPTION ("-in",             "Ignore NoOp opcodes");
     ACPI_OPTION ("-vt",             "Dump binary table data in hex format within output file");
 
@@ -319,16 +318,6 @@ main (
 
     /* Perform global actions first/only */
 
-    if (Gbl_GetAllTables)
-    {
-        Status = AslDoOneFile (NULL);
-        if (ACPI_FAILURE (Status))
-        {
-            return (-1);
-        }
-        return (0);
-    }
-
     if (Gbl_DisassembleAll)
     {
         while (argv[Index1])
diff --git a/sys/contrib/dev/acpica/source/compiler/aslmessages.h b/sys/contrib/dev/acpica/source/compiler/aslmessages.h
index ae066e2..a97766c 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslmessages.h
+++ b/sys/contrib/dev/acpica/source/compiler/aslmessages.h
@@ -445,7 +445,7 @@ char                        *AslMessages [] =
 /*    ASL_MSG_INVALID_FIELD_NAME */         "Invalid Field Name",
 /*    ASL_MSG_INVALID_HEX_INTEGER */        "Invalid hex integer constant",
 /*    ASL_MSG_OEM_TABLE */                  "OEM table - unknown contents",
-/*    ASL_MSG_RESERVED_VALUE */             "Reserved field must be zero",
+/*    ASL_MSG_RESERVED_VALUE */             "Reserved field",
 /*    ASL_MSG_UNKNOWN_LABEL */              "Label is undefined",
 /*    ASL_MSG_UNKNOWN_SUBTABLE */           "Unknown subtable type",
 /*    ASL_MSG_UNKNOWN_TABLE */              "Unknown ACPI table signature",
diff --git a/sys/contrib/dev/acpica/source/compiler/asloptions.c b/sys/contrib/dev/acpica/source/compiler/asloptions.c
index 2963565..7d73d20 100644
--- a/sys/contrib/dev/acpica/source/compiler/asloptions.c
+++ b/sys/contrib/dev/acpica/source/compiler/asloptions.c
@@ -118,8 +118,7 @@ AslCommandLine (
     /* Next parameter must be the input filename */
 
     if (!argv[AcpiGbl_Optind] &&
-        !Gbl_DisasmFlag &&
-        !Gbl_GetAllTables)
+        !Gbl_DisasmFlag)
     {
         printf ("Missing input filename\n");
         BadCommandLine = TRUE;
@@ -318,9 +317,8 @@ AslDoOptions (
 
     case 'g':   /* Get all ACPI tables */
 
-        Gbl_GetAllTables = TRUE;
-        Gbl_DoCompile = FALSE;
-        break;
+        printf ("-g option is deprecated, use acpidump utility instead\n");
+        exit (1);
 
     case 'h':
 
diff --git a/sys/contrib/dev/acpica/source/compiler/aslpredef.c b/sys/contrib/dev/acpica/source/compiler/aslpredef.c
index bdede7b..33f6be9 100644
--- a/sys/contrib/dev/acpica/source/compiler/aslpredef.c
+++ b/sys/contrib/dev/acpica/source/compiler/aslpredef.c
@@ -251,10 +251,16 @@ ApCheckPredefinedReturnValue (
     const ACPI_PREDEFINED_INFO  *ThisName;
 
 
-    /* Check parent method for a match against the predefined name list */
-
+    /*
+     * Check parent method for a match against the predefined name list.
+     *
+     * Note: Disable compiler errors/warnings because any errors will be
+     * caught when analyzing the parent method. Eliminates duplicate errors.
+     */
+    Gbl_AllExceptionsDisabled = TRUE;
     Index = ApCheckForPredefinedName (MethodInfo->Op,
                 MethodInfo->Op->Asl.NameSeg);
+    Gbl_AllExceptionsDisabled = FALSE;
 
     switch (Index)
     {
